/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#include "Rogus.h"
#include "fooFinder.h"

// You should define Rogus preference variables here
bool statistics_on = 1;
const char* default_input = "sound blaster";
const char* default_output = "sound blaster";

// Rogus parsers are registered by a very elegant scheme where they merely need to be linked
// into the executable to be registered. However, CodeWarrior does not link them in unless there
// is a symbol reference to the object file. This means that we have to resort to an ugly hack
// to get our elegant technique to work. What you need to do it give your parser a static
// member named foo, and then #include the parsers header file from this file, and then
// access its foo member in the function fooFinder, below. This will make sure it is linked in,
// so its ParserRegistration constructor will be called.

#include "print_parser.h"
#include "gliss_parser.h"
#include "octave_parser.h"
#include "octave_parser2.h"
#include "score_parser.h"
#include "MimicParser.h"

void fooFinder()
{
	print_parser::foo++;
	gliss_parser::foo++;
	octave_parser::foo++;
	octave_parser2::foo++;
	score_parser::foo++;
	MimicParser::foo++;
}

// Author: Patrick Pelletier
